/*********************************************/
/**                 system USER !!!          */
/*********************************************/
/* 1 */
/* ARCHIVE LOG MODE */
sudo docker exec -it oracle21c sqlplus sys/oracle AS SYSDBA
SHUTDOWN IMMEDIATE;
STARTUP MOUNT;
ALTER DATABASE ARCHIVELOG;
ALTER DATABASE OPEN;
SELECT NAME,
       LOG_MODE
FROM   V$DATABASE;
exit;

/* 2 */
/* TABLESPACE and USERS */
DROP TABLESPACE TBS_GRIESMAYER_BACKUP INCLUDING CONTENTS AND DATAFILES;
DROP USER BANK CASCADE;
DROP USER GRIESMAYER CASCADE;
DROP USER THOMAS CASCADE;

CREATE SMALLFILE TABLESPACE TBS_GRIESMAYER_BACKUP
DATAFILE '/opt/oracle/oradata/XE/XEPDB1/griesmayer_backup1.dbf' SIZE 10M
AUTOEXTEND ON NEXT 1M MAXSIZE UNLIMITED
LOGGING EXTENT MANAGEMENT LOCAL SEGMENT SPACE MANAGEMENT AUTO;

CREATE USER BANK PROFILE "DEFAULT" IDENTIFIED BY "oracle"
DEFAULT TABLESPACE TBS_GRIESMAYER_BACKUP
TEMPORARY TABLESPACE TEMP
ACCOUNT LOCK;

GRANT UNLIMITED TABLESPACE TO BANK;
   
CREATE USER GRIESMAYER PROFILE "DEFAULT" IDENTIFIED BY "oracle"
DEFAULT TABLESPACE TBS_GRIESMAYER_BACKUP
TEMPORARY TABLESPACE TEMP
ACCOUNT UNLOCK;

CREATE USER THOMAS PROFILE "DEFAULT" IDENTIFIED BY "oracle"
DEFAULT TABLESPACE TBS_GRIESMAYER_BACKUP
TEMPORARY TABLESPACE TEMP
ACCOUNT UNLOCK;

GRANT SELECT ANY DICTIONARY TO GRIESMAYER;
GRANT CONNECT TO GRIESMAYER;
GRANT CREATE ANY TABLE TO GRIESMAYER;
GRANT DROP ANY TABLE TO GRIESMAYER;
GRANT UNLIMITED TABLESPACE TO GRIESMAYER;
GRANT CREATE ANY SEQUENCE TO GRIESMAYER;
GRANT DROP ANY SEQUENCE TO GRIESMAYER;
GRANT SELECT ANY SEQUENCE TO GRIESMAYER;
GRANT RESOURCE TO GRIESMAYER;
GRANT CREATE ANY TRIGGER TO GRIESMAYER;
GRANT DROP ANY TRIGGER TO GRIESMAYER;
GRANT CREATE ANY PROCEDURE TO GRIESMAYER;
GRANT DROP ANY PROCEDURE TO GRIESMAYER;

GRANT CONNECT TO THOMAS;
GRANT RESOURCE TO THOMAS;



/*********************************************/
/**                 griesmayer USER !!!      */
/*********************************************/
/* 3 */
/* SEQUENCE, TRIGGER, ... */
DROP SEQUENCE BANK.SEQ_CUSTOMER_ID;

CREATE SEQUENCE BANK.SEQ_CUSTOMER_ID START WITH 1;

SELECT BANK.SEQ_CUSTOMER_ID.NEXTVAL
FROM   DUAL;

DROP TABLE FIRSTNAME;

CREATE TABLE FIRSTNAME
(
   FIRST_NAME_ID INTEGER NOT NULL PRIMARY KEY,
   FIRST_NAME    CHAR(20),
   GENDER        CHAR(1)
);

INSERT INTO FIRSTNAME VALUES (1 ,  'Anna', 'f');
INSERT INTO FIRSTNAME VALUES (2 ,  'Hannah', 'f');
INSERT INTO FIRSTNAME VALUES (3 ,  'Lena', 'f');
INSERT INTO FIRSTNAME VALUES (4 ,  'Sarah', 'f');
INSERT INTO FIRSTNAME VALUES (5 ,  'Sophie', 'f');
INSERT INTO FIRSTNAME VALUES (6 ,  'Emma', 'f');
INSERT INTO FIRSTNAME VALUES (7 ,  'Julia', 'f');
INSERT INTO FIRSTNAME VALUES (8 ,  'Marie', 'f');
INSERT INTO FIRSTNAME VALUES (9 ,  'Leonie', 'f');
INSERT INTO FIRSTNAME VALUES (10,  'Laura', 'f');
INSERT INTO FIRSTNAME VALUES (11,  'Valentina', 'f');
INSERT INTO FIRSTNAME VALUES (12,  'Sophia', 'f');
INSERT INTO FIRSTNAME VALUES (13,  'Lea', 'f');
INSERT INTO FIRSTNAME VALUES (14,  'Mia', 'f');
INSERT INTO FIRSTNAME VALUES (15,  'Johanna', 'f');
INSERT INTO FIRSTNAME VALUES (16,  'Katharina', 'f');
INSERT INTO FIRSTNAME VALUES (17,  'Lara', 'f');
INSERT INTO FIRSTNAME VALUES (18,  'Emilia', 'f');
INSERT INTO FIRSTNAME VALUES (19,  'Amelie', 'f');
INSERT INTO FIRSTNAME VALUES (20,  'Magdalena', 'f');
INSERT INTO FIRSTNAME VALUES (21,  'Lisa', 'f');
INSERT INTO FIRSTNAME VALUES (22,  'Luisa', 'f');
INSERT INTO FIRSTNAME VALUES (23,  'Jana', 'f');
INSERT INTO FIRSTNAME VALUES (24,  'Clara', 'f');
INSERT INTO FIRSTNAME VALUES (25,  'Viktoria', 'f');
INSERT INTO FIRSTNAME VALUES (26,  'Nina', 'f');
INSERT INTO FIRSTNAME VALUES (27,  'Theresa', 'f');
INSERT INTO FIRSTNAME VALUES (28,  'Elena', 'f');
INSERT INTO FIRSTNAME VALUES (29,  'Emily', 'f');
INSERT INTO FIRSTNAME VALUES (30,  'Isabella', 'f');
INSERT INTO FIRSTNAME VALUES (31,  'Alina', 'f');
INSERT INTO FIRSTNAME VALUES (32,  'Marlene', 'f');
INSERT INTO FIRSTNAME VALUES (33,  'Lina', 'f');
INSERT INTO FIRSTNAME VALUES (34,  'Helena', 'f');
INSERT INTO FIRSTNAME VALUES (35,  'Selina', 'f');
INSERT INTO FIRSTNAME VALUES (36,  'Lilly', 'f');
INSERT INTO FIRSTNAME VALUES (37,  'Annika', 'f');
INSERT INTO FIRSTNAME VALUES (38,  'Miriam', 'f');
INSERT INTO FIRSTNAME VALUES (39,  'Pia', 'f');
INSERT INTO FIRSTNAME VALUES (40,  'Vanessa', 'f');
INSERT INTO FIRSTNAME VALUES (41,  'Nora', 'f');
INSERT INTO FIRSTNAME VALUES (42,  'Elisa', 'f');
INSERT INTO FIRSTNAME VALUES (43,  'Eva', 'f');
INSERT INTO FIRSTNAME VALUES (44,  'Emely', 'f');
INSERT INTO FIRSTNAME VALUES (45,  'Anna-Lena', 'f');
INSERT INTO FIRSTNAME VALUES (46,  'Franziska', 'f');
INSERT INTO FIRSTNAME VALUES (47,  'Maja', 'f');
INSERT INTO FIRSTNAME VALUES (48,  'Paula', 'f');
INSERT INTO FIRSTNAME VALUES (49,  'Larissa', 'f');
INSERT INTO FIRSTNAME VALUES (50,  'Valerie', 'f');
INSERT INTO FIRSTNAME VALUES (51,  'Ella', 'f');
INSERT INTO FIRSTNAME VALUES (52,  'Jasmin', 'f');
INSERT INTO FIRSTNAME VALUES (53,  'Elisabeth', 'f');
INSERT INTO FIRSTNAME VALUES (54,  'Anja', 'f');
INSERT INTO FIRSTNAME VALUES (55,  'Antonia', 'f');
INSERT INTO FIRSTNAME VALUES (56,  'Maria', 'f');
INSERT INTO FIRSTNAME VALUES (57,  'Fabienne', 'f');
INSERT INTO FIRSTNAME VALUES (58,  'Isabel', 'f');
INSERT INTO FIRSTNAME VALUES (59,  'Livia', 'f');
INSERT INTO FIRSTNAME VALUES (60,  'Christina', 'f');
INSERT INTO FIRSTNAME VALUES (61,  'Lukas', 'm');
INSERT INTO FIRSTNAME VALUES (62,  'Tobias', 'm');
INSERT INTO FIRSTNAME VALUES (63,  'Maximilian', 'm');
INSERT INTO FIRSTNAME VALUES (64,  'Luca', 'm');
INSERT INTO FIRSTNAME VALUES (65,  'David', 'm');
INSERT INTO FIRSTNAME VALUES (66,  'Jakob', 'm');
INSERT INTO FIRSTNAME VALUES (67,  'Felix', 'm');
INSERT INTO FIRSTNAME VALUES (68,  'Elias', 'm');
INSERT INTO FIRSTNAME VALUES (69,  'Jonas', 'm');
INSERT INTO FIRSTNAME VALUES (70,  'Paul', 'm');
INSERT INTO FIRSTNAME VALUES (71,  'Alexander', 'm');
INSERT INTO FIRSTNAME VALUES (72,  'Raphael', 'm');
INSERT INTO FIRSTNAME VALUES (73,  'Sebastian', 'm');
INSERT INTO FIRSTNAME VALUES (74,  'Julian', 'm');
INSERT INTO FIRSTNAME VALUES (75,  'Simon', 'm');
INSERT INTO FIRSTNAME VALUES (76,  'Leon', 'm');
INSERT INTO FIRSTNAME VALUES (77,  'Fabian', 'm');
INSERT INTO FIRSTNAME VALUES (78,  'Florian', 'm');
INSERT INTO FIRSTNAME VALUES (79,  'Moritz', 'm');
INSERT INTO FIRSTNAME VALUES (80,  'Philipp', 'm');
INSERT INTO FIRSTNAME VALUES (81,  'Matthias', 'm');
INSERT INTO FIRSTNAME VALUES (82,  'Nico', 'm');
INSERT INTO FIRSTNAME VALUES (83,  'Noah', 'm');
INSERT INTO FIRSTNAME VALUES (84,  'Michael', 'm');
INSERT INTO FIRSTNAME VALUES (85,  'Samuel', 'm');
INSERT INTO FIRSTNAME VALUES (86,  'Benjamin', 'm');
INSERT INTO FIRSTNAME VALUES (87,  'Daniel', 'm');
INSERT INTO FIRSTNAME VALUES (88,  'Niklas', 'm');
INSERT INTO FIRSTNAME VALUES (89,  'Dominik', 'm');
INSERT INTO FIRSTNAME VALUES (90,  'Johannes', 'm');
INSERT INTO FIRSTNAME VALUES (91,  'Lorenz', 'm');
INSERT INTO FIRSTNAME VALUES (92,  'Marcel', 'm');
INSERT INTO FIRSTNAME VALUES (93,  'Leo', 'm');
INSERT INTO FIRSTNAME VALUES (94,  'Gabriel', 'm');
INSERT INTO FIRSTNAME VALUES (95,  'Valentin', 'm');
INSERT INTO FIRSTNAME VALUES (96,  'Matteo', 'm');
INSERT INTO FIRSTNAME VALUES (97,  'Jan', 'm');
INSERT INTO FIRSTNAME VALUES (98,  'Stefan', 'm');
INSERT INTO FIRSTNAME VALUES (99,  'Konstantin', 'm');
INSERT INTO FIRSTNAME VALUES (100, 'Manuel', 'm');
INSERT INTO FIRSTNAME VALUES (101, 'Luis', 'm');
INSERT INTO FIRSTNAME VALUES (102, 'Emil', 'm');
INSERT INTO FIRSTNAME VALUES (103, 'Marco', 'm');
INSERT INTO FIRSTNAME VALUES (104, 'Thomas', 'm');
INSERT INTO FIRSTNAME VALUES (105, 'Ben', 'm');
INSERT INTO FIRSTNAME VALUES (106, 'Clemens', 'm');
INSERT INTO FIRSTNAME VALUES (107, 'Fabio', 'm');
INSERT INTO FIRSTNAME VALUES (108, 'Kilian', 'm');
INSERT INTO FIRSTNAME VALUES (109, 'Andreas', 'm');
INSERT INTO FIRSTNAME VALUES (110, 'Christoph', 'm');
INSERT INTO FIRSTNAME VALUES (111, 'Tim', 'm');
INSERT INTO FIRSTNAME VALUES (112, 'Max', 'm');
INSERT INTO FIRSTNAME VALUES (113, 'Jonathan', 'm');
INSERT INTO FIRSTNAME VALUES (114, 'Martin', 'm');
INSERT INTO FIRSTNAME VALUES (115, 'Adrian', 'm');
INSERT INTO FIRSTNAME VALUES (116, 'Oliver', 'm');
INSERT INTO FIRSTNAME VALUES (117, 'Timo', 'm');
INSERT INTO FIRSTNAME VALUES (118, 'Laurenz', 'm');
INSERT INTO FIRSTNAME VALUES (119, 'Christian', 'm');
INSERT INTO FIRSTNAME VALUES (120, 'Anton', 'm');

COMMIT;

DROP TABLE BANK.CUSTOMER;

CREATE TABLE BANK.CUSTOMER
(
	CUSTOMER_ID  INTEGER,
	FIRST_NAME   CHAR(20),
    GENDER       CHAR(1),
	BALANCE      DECIMAL(10,2),
    CREDIT_LIMIT DECIMAL(10,2)
);

COMMIT;

CREATE OR REPLACE TRIGGER BANK.TRG_CUSTOMER
BEFORE INSERT or UPDATE on BANK.CUSTOMER
FOR EACH ROW
BEGIN
  IF (INSERTING) THEN
    :new.CUSTOMER_ID := BANK.SEQ_CUSTOMER_ID.nextval;

    IF ((:new.CREDIT_LIMIT is NULL) or (:new.CREDIT_LIMIT > 0)) THEN
      :new.CREDIT_LIMIT := -1000;
    END IF;
  END IF;

  IF (UPDATING) THEN
    IF (:old.CUSTOMER_ID <> :new.CUSTOMER_ID) THEN
      raise_application_error (-20998, 'Cannot change the ACCOUNT_ID!');
    END IF;

    IF (abs(:new.BALANCE - :old.BALANCE) > 1000) THEN
      raise_application_error (-20997, 'The transaction is limited by 1000€!');
    END IF;
  END IF;

  IF (:new.BALANCE < :new.CREDIT_LIMIT) THEN
    raise_application_error (-20999, 'The balance ' || :new.BALANCE || ' is under the credit limit' || :new.CREDIT_LIMIT || '!');
  END IF;
END;

COMMIT;

DROP TABLE BANK.TRANSFER;

CREATE TABLE BANK.TRANSFER
(
	CUSTOMER_ID_FROM INTEGER,
	CUSTOMER_ID_TO   INTEGER,
	TRANSFER_DATE    DATE,
	AMOUNT           DECIMAL(10,2)
);

COMMIT;

DROP TRIGGER BANK.TRG_TRANSFER

CREATE OR REPLACE TRIGGER BANK.TRG_TRANSFER
BEFORE INSERT on BANK.TRANSFER
FOR EACH ROW
BEGIN
    :new.TRANSFER_DATE := SYSDATE;
END;

COMMIT;
										
CREATE OR REPLACE PROCEDURE
BANK.PROC_TRANSFER (CUSTOMER_ID_FROM IN    NUMBER,
                    CUSTOMER_ID_TO   IN    NUMBER,
                    TRANSFER_DATE    OUT   DATE,
                    TRANSFER_AMOUNT  IN    NUMBER) IS
V_COUNT NUMBER;
BEGIN
   TRANSFER_DATE := SYSDATE;

   IF (TRANSFER_AMOUNT <= 0) THEN
      raise_application_error (-20999, 'The Amount must be a positive number!');
   END IF;

   SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

   SELECT count(*) INTO V_COUNT
   FROM   BANK.CUSTOMER
   WHERE  CUSTOMER_ID = CUSTOMER_ID_FROM;

   IF (V_COUNT = 0) THEN
      ROLLBACK;
      raise_application_error (-20998, 'Customer_ID_FROM does not exist!');
   END IF;
   
   SELECT count(*) INTO V_COUNT
   FROM   BANK.CUSTOMER
   WHERE  CUSTOMER_ID = CUSTOMER_ID_TO;

   IF (V_COUNT = 0) THEN
      ROLLBACK;
      raise_application_error (-20997, 'Customer_ID_TO does not exist!');
   END IF;
   
   UPDATE BANK.CUSTOMER
   SET    BALANCE = BALANCE - TRANSFER_AMOUNT
   WHERE  CUSTOMER_ID = CUSTOMER_ID_FROM;

   UPDATE BANK.CUSTOMER
   SET    BALANCE = BALANCE + TRANSFER_AMOUNT
   WHERE  CUSTOMER_ID = CUSTOMER_ID_TO;
   
   INSERT INTO BANK.TRANSFER VALUES (CUSTOMER_ID_FROM, CUSTOMER_ID_TO, NULL, TRANSFER_AMOUNT);
   
   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
   ROLLBACK;
   raise_application_error(SQLCODE, SQLERRM);
END;



/*********************************************/
/**                 system USER !!!          */
/*********************************************/
/* 4 */
/* OBJECT RIGHTS */
GRANT INSERT, SELECT, UPDATE, DELETE ON BANK.CUSTOMER TO GRIESMAYER;
GRANT INSERT, SELECT, UPDATE, DELETE ON BANK.TRANSFER TO GRIESMAYER;
GRANT EXECUTE ON BANK.PROC_TRANSFER TO GRIESMAYER;

GRANT SELECT ON BANK.CUSTOMER TO THOMAS;
GRANT SELECT ON BANK.TRANSFER TO THOMAS;



/*********************************************/
/**                 griesmayer USER !!!      */
/*********************************************/
/* 5 */
/* TEST DATA */
INSERT INTO BANK.CUSTOMER
SELECT NULL as CUSTOMER_ID,
       nam.FIRST_NAME,
       nam.GENDER,
       CAST((DBMS_RANDOM.VALUE*2000-500) AS DECIMAL(10,2)) as BALANCE,
       NULL AS CREDIT_LIMIT
FROM   DUAL cus
       INNER JOIN
       FIRSTNAME nam
       ON (CAST(DBMS_RANDOM.VALUE*119 AS INTEGER)+1) = nam.FIRST_NAME_ID;
       
INSERT INTO BANK.CUSTOMER
SELECT NULL AS CUSTOMER_ID,
       nam.FIRST_NAME,
       nam.GENDER,
       CAST((DBMS_RANDOM.VALUE*2000) AS DECIMAL(10,2)) as BALANCE,
       (CAST(DBMS_RANDOM.VALUE*2 AS INTEGER))*1000 as CREDIT_LIMIT
FROM   (
          SELECT (CAST(DBMS_RANDOM.VALUE*119 AS INTEGER)+1) as FIRST_NAME_ID
          FROM   BANK.CUSTOMER
       ) cus
       INNER JOIN
       FIRSTNAME nam
       ON cus.FIRST_NAME_ID = nam.FIRST_NAME_ID;

COMMIT;



/*********************************************/
/**                 thomas USER !!!          */
/*********************************************/
/* 6 */
/* CHECK */
SELECT sum(BALANCE)
FROM   BANK.CUSTOMER;

SELECT count(*)
FROM   BANK.TRANSFER;



/*********************************************/
/**                 griesmayer USER !!!      */
/*********************************************/
/* 6 */
/* PRODUCTION SYSTEM */
DECLARE
   TRAN_DATE DATE;
   CUSTOMER_ID_FROM NUMBER;
   CUSTOMER_ID_TO NUMBER;
   AMOUNT NUMBER;
   ANZ NUMBER;
BEGIN
   ANZ := 1;
   WHILE ANZ<1000 LOOP
      BEGIN
         SELECT CAST(DBMS_RANDOM.VALUE*2000 AS INTEGER)-100 INTO CUSTOMER_ID_FROM
         FROM   DUAL;
         SELECT CAST(DBMS_RANDOM.VALUE*2000 AS INTEGER)-100 INTO CUSTOMER_ID_TO
         FROM   DUAL;
         SELECT CAST((DBMS_RANDOM.VALUE*400) AS DECIMAL(10,2))-10 INTO AMOUNT
         FROM   DUAL;

         BANK.PROC_TRANSFER (CUSTOMER_ID_FROM, CUSTOMER_ID_TO, TRAN_DATE, AMOUNT);
         --DBMS_OUTPUT.PUT_LINE(TRAN_DATE);
         ANZ := ANZ+1;
      EXCEPTION
         WHEN OTHERS THEN
            DBMS_OUTPUT.PUT_LINE(SQLERRM);
      END;
   END LOOP;
END;



/*********************************************/
/**                 sys USER !!!             */
/*********************************************/
/* 7 */
/* BACKUP */
sudo docker exec -it oracle21c sqlplus sys/oracle@XEPDB1 AS SYSDBA
ALTER TABLESPACE TBS_GRIESMAYER_BACKUP BEGIN BACKUP;
host
mkdir ~/backup
rm ~/backup/.
cp /opt/oracle/oradata/XE/XEPDB1/griesmayer_backup*.dbf ~/backup
exit
ALTER TABLESPACE TBS_GRIESMAYER_BACKUP END BACKUP;
exit;



/*********************************************/
/**                 thomas USER !!!          */
/*********************************************/
/* 8 */
/* CHECK */
SELECT sum(BALANCE)
FROM   BANK.CUSTOMER;

SELECT count(*)
FROM   BANK.TRANSFER;


/*********************************************/
/**                 sys USER !!!             */
/*********************************************/
/* 9 */
/* HARDDISK CRASH */
sudo docker exec -it oracle21c sqlplus sys/oracle AS SYSDBA
SHUTDOWN ABORT;
host
rm /opt/oracle/oradata/XE/XEPDB1/griesmayer_backup*.dbf
exit;
STARTUP;
ALTER PLUGGABLE DATABASE ALL OPEN;
host
cp ~/backup/griesmayer_backup*.dbf /opt/oracle/oradata/XE/XEPDB1/
exit;

/* 10 */
/* RECOVER */
sudo docker exec -it oracle21c /bin/bash
rman target /
alter pluggable database XEPDB1 close;
restore pluggable database XEPDB1;
recover pluggable database XEPDB1;
alter pluggable database XEPDB1 open;
exit;

sudo docker exec -it oracle21c sqlplus sys/oracle@XEPDB1 AS SYSDBA
STARTUP;
exit;


/*********************************************/
/**                 thomas USER !!!          */
/*********************************************/
/* 11 */
/* FINAL CHECK */
SELECT sum(BALANCE)
FROM   BANK.CUSTOMER;

SELECT count(*)
FROM   BANK.TRANSFER;
